import { Mapping } from "./change";
import { EditorState } from "./state";
export declare class SelectionRange {
    readonly anchor: number;
    readonly head: number;
    constructor(anchor: number, head?: number);
    readonly from: number;
    readonly to: number;
    readonly empty: boolean;
    map(mapping: Mapping): SelectionRange;
    extend(from: number, to?: number): SelectionRange;
    eq(other: SelectionRange): boolean;
    static groupAt(state: EditorState, pos: number, bias?: 1 | -1): SelectionRange;
}
export declare class EditorSelection {
    readonly ranges: ReadonlyArray<SelectionRange>;
    readonly primaryIndex: number;
    /** @internal */
    constructor(ranges: ReadonlyArray<SelectionRange>, primaryIndex?: number);
    map(mapping: Mapping): EditorSelection;
    eq(other: EditorSelection): boolean;
    readonly primary: SelectionRange;
    asSingle(): EditorSelection;
    addRange(range: SelectionRange, primary?: boolean): EditorSelection;
    replaceRange(range: SelectionRange, which?: number): EditorSelection;
    static single(anchor: number, head?: number): EditorSelection;
    static create(ranges: ReadonlyArray<SelectionRange>, primaryIndex?: number): EditorSelection;
    static default: EditorSelection;
}
