import { ContentView } from "./contentview";
import { DocView } from "./docview";
import { InlineView, LineContent } from "./inlineview";
import { Rect } from "./dom";
import { WidgetType } from "./decoration";
export declare class LineView extends ContentView {
    children: InlineView[];
    widgets: LineWidget[];
    length: number;
    dom: HTMLElement;
    prevAttrs: {
        [name: string]: string;
    } | null | undefined;
    attrs: {
        [name: string]: string;
    } | null;
    constructor(parent: DocView, content?: LineContent, tail?: InlineView[]);
    setDeco(content: LineContent): void;
    update(from: number, to: number, content: LineContent, tail?: InlineView[]): void;
    detachTail(from: number): InlineView[];
    domFromPos(pos: number): {
        node: Node;
        offset: number;
    };
    syncInto(parent: HTMLElement, pos: Node | null): Node | null;
    sync(): void;
    measureTextSize(): {
        lineHeight: number;
        charWidth: number;
    } | null;
    coordsAt(pos: number): Rect | null;
    ignoreMutation(rec: MutationRecord): boolean;
    ignoreEvent(event: Event): boolean;
}
export declare class LineWidget {
    readonly widget: WidgetType<any>;
    readonly side: number;
    dom: HTMLElement | null;
    constructor(widget: WidgetType<any>, side: number);
    eq(other: LineWidget): boolean;
    finish(): this;
}
